/*
	Author: Pietro Falcone - info@venice-live.com
	date:   August 21st, 2007
	
	http://live-venice.com/
	http://venetianrooms.com/
	Copyright 2007
*/

var reverseCounter = 30;
var counter = Math.random()*1000000;
var pref2 = 1;
var rotating = 1;
var random = 1;
var boolHide = 1;
var boolFirst = 1;

function changeWorld(elem)
{	
	switch( parseInt(elem.options[elem.selectedIndex].value) )				
	{
		case 1: 										
			pref2 = 1;
			reverseCounter = 30;
			if(window.widget)
			{
				widget.setPreferenceForKey(1,"pref2");		
			}
			break;
			
		case 2:										
			pref2 = 2;
			reverseCounter = 30;
			if(window.widget)
			{
				widget.setPreferenceForKey(2,"pref2");
			}
			break;
		
		case 3:										
			pref2 = 3;
			reverseCounter = 30;
			if(window.widget)
			{
				widget.setPreferenceForKey(3,"pref2");
			}
			break;
			
		case 4:										
			pref2 = 4;
			reverseCounter = 30;
			if(window.widget)
			{
				widget.setPreferenceForKey(4,"pref2");
			}
			break;
			
		case 5:										
			pref2 = 5;
			reverseCounter = 30;
			if(window.widget)
			{
				widget.setPreferenceForKey(5,"pref2");
			}
			break;			
			
		case 6:										
			pref2 = 6;	
			reverseCounter = 15;
			if(window.widget)
			{
				widget.setPreferenceForKey(6,"pref2");
			}
			break;
			
		case 7:										
			pref2 = 7;
			reverseCounter = 30;
			if(window.widget)
			{
				widget.setPreferenceForKey(7,"pref2");
			}
			var ran_unrounded=Math.random()*4;
	   		random = Math.round(ran_unrounded) + 1;	
			break;			
	}
} 


function setup() 
{
	if (window.widget) {
      	widget.onhide = onhide;
		widget.onshow = onshow;
		widget.onremove = onremove;
	}
	boolFirst = 1;
	readPrefs();
	engine();
}

function onshow() 
{	
	boolHide = 1;
	boolFirst = 1;
	var ran_unrounded=Math.random() * 4;
	random = Math.round(ran_unrounded) + 1;		
	readPrefs();
	engine();
}

function onhide() 
{	
	boolHide = 0;
	readPrefs();
}

function readPrefs() 
{
	if (!widget.preferenceForKey("pref2"))
	{
		pref2 = 1;
	}	
	else
	{
		pref2 = widget.preferenceForKey("pref2");
	}	
}

function engine() 
{
	
	if (boolFirst == 1)
	{
		boolFirst = 0;
		timeRemaining = 1;
	}

	timeRemaining--;
	counter++;
	
	if (boolHide == 1)
	{
		self.setTimeout('engine()', 1000);
	}
	
	if (timeRemaining <= 0) 
	{
		if ( pref2 == 1 )
		{
			document.venice.src = "http://turismo.regione.veneto.it/webcam/full.jpg" + "?" + counter;	
		}
		else if ( pref2 == 2 )
		{
			document.venice.src = "http://www2.comune.venezia.it/webCamPsm/imgpsm_00001.jpg" + "?" + counter;
		}
		else if ( pref2 == 3 )
		{
			document.venice.src = "http://www2.comune.venezia.it/webCamSnf/imgsnf_00001.jpg" + "?" + counter;
		}
		else if ( pref2 == 4 )
		{
			document.venice.src = "http://www2.comune.venezia.it/webcamsantachiara/imgbridge4_00001.jpg" + "?" + counter;
		}
		else if ( pref2 == 5 )
		{
			document.venice.src = "http://www2.comune.venezia.it/webcamrialto/imgbridge2_00001.jpg" + "?" + counter;
		}
		else if( pref2 == 6 )
		{		
			if (rotating == 1)
			{
				document.venice.src = "http://turismo.regione.veneto.it/webcam/full.jpg" + "?" + counter;
				rotating++;
			}
			else if (rotating == 2)
			{
				document.venice.src = "http://www2.comune.venezia.it/webCamPsm/imgpsm_00001.jpg" + "?" + counter;
				rotating++;
			}
			else if (rotating == 3)
			{
				document.venice.src = "http://www2.comune.venezia.it/webCamSnf/imgsnf_00001.jpg" + "?" + counter;
				rotating++;
			}
			else if (rotating == 4)
			{
				document.venice.src = "http://www2.comune.venezia.it/webcamsantachiara/imgbridge4_00001.jpg" + "?" + counter;
				rotating++;
			}			
			else if (rotating == 5)
			{
				document.venice.src = "http://www2.comune.venezia.it/webcamrialto/imgbridge2_00001.jpg" + "?" + counter;
				rotating = 1;
			}
	   }
	   else if( pref2 == 7 )
	   {
			if (random == 1)
			{
				document.venice.src = "http://turismo.regione.veneto.it/webcam/full.jpg" + "?" + counter;
			}
			else if (random == 2)
			{
				document.venice.src = "http://www2.comune.venezia.it/webCamPsm/imgpsm_00001.jpg" + "?" + counter;
			}
			else if (random == 3)
			{
				document.venice.src = "http://www2.comune.venezia.it/webCamSnf/imgsnf_00001.jpg" + "?" + counter;
			}
			else if (random == 4)
			{
				document.venice.src = "http://www2.comune.venezia.it/webcamsantachiara/imgbridge4_00001.jpg" + "?" + counter;
			}
			else if (random == 5)
			{
				document.venice.src = "http://www2.comune.venezia.it/webcamrialto/imgbridge2_00001.jpg" + "?" + counter;
			}

		}	
		counter++;
		timeRemaining = reverseCounter;
	}
}



/*********** Apple's functions ***********/
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	boolHide = 0;
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
		
	boolHide = 1;
	onshow();
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function goTo(url)
{
	if (window.widget)
	{
		widget.openURL(url);
	}
}